/*
 * $Id: olio.c,v 1.8 2002/04/08 07:56:05 nletwory Exp $
 *
 * Olion toteutus
 *
 */

#include "yleiset.h"

extern int volkkari_x;
extern int volkkari_y;

/* http://www.abcme.com/peacesigncollection/peacesigncoll.html */

extern int kerroin;
extern int vieritty;

extern int kolari;
extern int tappo;
extern int bonus;

extern int saadut_bonukset;

int vel = 1;
int kaasuttu = 0;
int jarruttu = 0;

extern BITMAP *pieni_vw_oikea;
extern BITMAP *pieni_vw_vasen;

/* joitakin tasoja */

unsigned int taso_yksi_pituus = 2700;
olio taso_yksi[] = {
	{1,	BILE,	214,	780,	50,	70,	0,	0,	0,	NULL},
	{2,	BILE,	378,	880,	50,	70,	0,	1,	0,	NULL},
	{3,	BILE,	214,	950,	50,	70,	0,	0,	0,	NULL},
	{4,	BILE,	378,	970,	50,	70,	0,	1,	0,	NULL},
	{5,	BILE,	214,	1040,	50,	70,	0,	0,	0,	NULL},
	{6,	BILE,	214,	1220,	50,	70,	0,	0,	0,	NULL},
	{7,	BILE,	378,	1210,	50,	70,	0,	1,	0,	NULL},
	{8,	BILE,	378,	1380,	50,	70,	0,	1,	0,	NULL},
	{9,	BILE,	378,	1500,	50,	70,	0,	1,	0,	NULL},
	{10,	BILE,	214,	1300,	50,	70,	0,	0,	0,	NULL},
	{11,	BILE,	378,	1640,	50,	70,	0,	1,	0,	NULL},
	{12,	BILE,	378,	1720,	50,	70,	0,	1,	0,	NULL},
	{13,	BILE,	214,	1500,	50,	70,	0,	0,	0,	NULL},
	{14,	BILE,	214,	1600,	50,	70,	0,	0,	0,	NULL},
	{15,	BILE,	378,	1800,	50,	70,	0,	1,	0,	NULL},
	{16,	BILE,	378,	1940,	50,	70,	0,	1,	0,	NULL},
	{17,	BILE,	214,	1700,	50,	70,	0,	0,	0,	NULL},
	{18,	BILE,	214,	1790,	50,	70,	0,	0,	0,	NULL},
	{19,	BILE,	214,	2100,	50,	70,	0,	0,	0,	NULL},
	{20,	BILE,	378,	2200,	50,	70,	0,	1,	0,	NULL},
	{21,	KOTA,	460,	490,	100,	180,	0,	1,	0,	NULL},
	{22,	KOTA,	30,	550,	100,	180,	0,	0,	0,	NULL},
	{23,	KOTA,	450,	680,	100,	180,	0,	1,	0,	NULL},
	{24,	KOTA,	50,	780,	100,	180,	0,	0,	0,	NULL},
	{25,	KOTA,	10,	980,	100,	180,	0,	0,	0,	NULL},
	{26,	KOTA,	460,	1200,	100,	180,	0,	1,	0,	NULL},
	{27,	KOTA,	30,	1190,	100,	180,	0,	0,	0,	NULL},
	{28,	KOTA,	450,	1600,	100,	180,	0,	1,	0,	NULL},
	{29,	KOTA,	550,	1300,	100,	180,	0,	1,	0,	NULL},
	{30,	KOTA,	10,	1480,	100,	180,	0,	0,	0,	NULL},
	{31,	KOTA,	460,	1800,	100,	180,	0,	1,	0,	NULL},
	{32,	KOTA,	30,	1700,	100,	180,	0,	0,	0,	NULL},
	{33,	KOTA,	450,	1990,	100,	180,	0,	1,	0,	NULL},
	{34,	KOTA,	50,	2000,	100,	180,	0,	0,	0,	NULL},
	{35,	KOTA,	10,	2300,	100,	180,	0,	0,	0,	NULL},
	{36,	NAMU,	240,	880,	20,	20,	0,	0,	0,	NULL},
	{37,	NAMU,	244,	1400,	20,	20,	0,	0,	0,	NULL},
	{38,	NAMU,	390,	2100,	20,	20,	0,	0,	0,	NULL},
	{39,	NAMU,	390,	2400,	20,	20,	0,	0,	0,	NULL},
	{40,	NAMU,	290,	1800,	20,	20,	0,	0,	0,	NULL},
	{0,	BILE,	0,	0,	0,	0,	0,	0,	0,	NULL}
};

olio* lisaa_olio(olio* lista, olio uusi) {
	olio *tmp = lista;

	if(lista!=NULL) {
		while(lista->seuraava!=NULL) {
			lista = (olio *)lista->seuraava;
		}
		lista->seuraava = (struct olio *)malloc(sizeof(olio));
		lista = (olio *)lista->seuraava;
		lista->seuraava = NULL;
		lista->id = uusi.id;
		lista->tyyppi = uusi.tyyppi;
		lista->x = uusi.x;
		lista->y = uusi.y;
		lista->w = uusi.w;
		lista->h = uusi.h;
		lista->nopeus = uusi.nopeus;
		lista->suunta = uusi.suunta;
		lista->kuollut = uusi.kuollut;
		return tmp;
	} else {
		lista = (olio *)malloc(sizeof(olio));
		lista->seuraava = NULL;
		lista->id = uusi.id;
		lista->tyyppi = uusi.tyyppi;
		lista->x = uusi.x;
		lista->y = uusi.y;
		lista->w = uusi.w;
		lista->h = uusi.h;
		lista->nopeus = uusi.nopeus;
		lista->suunta = uusi.suunta;
		lista->kuollut = uusi.kuollut;
		return lista;
	}
}

void piirra_olio(olio* lista, BITMAP* bmp) {
	while(lista!=NULL) {
		switch(lista->tyyppi) {
			case BILE:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
						rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, 30); 
					/*if(lista->suunta) {
						masked_blit(pieni_vw_oikea,bmp, lista->x,(vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y,lista->w,lista->h);
						loki(".");
					} else {
						masked_blit(pieni_vw_vasen,bmp, lista->x,(vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y,lista->w,lista->h);
					}*/
				}
				break;
			case JALKA:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
					rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, makecol(20,100,100)); 
				}
				break;
			case KOTA:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
					//rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, makecol(200,180,100)); 
					masked_blit((BITMAP*)datfile[TALO].dat,bmp,0,0,lista->x,(vieritty+SCREEN_H)-(lista->y+lista->h),lista->w,lista->h);
				}
				break;
			case NAMU:
				if(!lista->kuollut) {
					if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
						rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, makecol(20,180,30)); 
						textprintf_centre(bmp,(FONT *)datfile[FORTE].dat,lista->x+lista->w/2,(vieritty+SCREEN_H)-(lista->y+lista->h),vieritty,"V");
					}
				} else {
					;/* Nada */
				}
				break;
			default:
				break;
		}
		lista = (olio *)lista->seuraava;
	}
}

void piirra_olion_valo(olio* lista, BITMAP* bmp) {
	while(lista!=NULL) {
		switch(lista->tyyppi) {
			case BILE:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
					//rectfill(bmp,lista->x-10, (vieritty+SCREEN_H)-(lista->y+lista->h)-10, lista->x+lista->w+10, (vieritty+SCREEN_H)-lista->y+10, 50); 
				}
				break;
			case JALKA:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
					//rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, makecol(20,100,100)); 
				}
				break;
			case KOTA:
				if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
					//rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, makecol(200,180,100)); 
					draw_trans_sprite(bmp,(BITMAP*)datfile[TALOVALO].dat,lista->x-50,(vieritty+SCREEN_H)-(lista->y+lista->h)-10);
				}
				break;
			case NAMU:
				if(!lista->kuollut) {
					if(( ((vieritty+SCREEN_H)-(lista->y+lista->h)) < SCREEN_H) && ( ((vieritty+SCREEN_H)-lista->y) > -1)) {
						//rectfill(bmp,lista->x, (vieritty+SCREEN_H)-(lista->y+lista->h), lista->x+lista->w, (vieritty+SCREEN_H)-lista->y, 180); 
					}
				} else {
					;/* Nada */
				}
				break;
			default:
				break;
		}
		lista = (olio *)lista->seuraava;
	}
}

void poksauta_taso(olio* lista) {
	while(lista!=NULL) {
		lista = poista_olio(lista);
	}
}

olio* poista_olio(olio* lista) {
	olio* tmp;
	tmp = (olio *)lista->seuraava;
	free(lista);
	loki("\t\t\tpoks\n");
	return tmp;
}

olio* lue_taso(olio* lista) {
	int c;

	c=0;
	loki("\t---> LUE_TASO()\n");

	while(taso_yksi[c].id!=0) {
		lista = lisaa_olio(lista,taso_yksi[c]);
		//loki("\t\tadded taso_yksi[c].id: %d\n", taso_yksi[c].id);
		c++;
	}

	loki("\t---> END LUE_TASO()\n");

	return lista;
}

void kirjoita_taso(olio* lista) {
#if 0
	{ ////////////////////////////////////////
	if(lista == NULL) {
		loki("\tTyhj lista annettu\n");
	} else {
		while(lista!=NULL) {
			loki("\tolio->id:%d\n",lista->id);
			loki("\tolio->tyyppi:%d\n",lista->tyyppi);
			loki("\tolio->x:%d\n",lista->x);
			loki("\tolio->y:%d\n",lista->y);
			loki("\tolio->w:%d\n",lista->w);
			loki("\tolio->h:%d\n",lista->h);
			lista = (olio *)lista->seuraava;
		}
	}
} //////////////////////////////////////
#endif
}

int olio_tormays_testi(olio *lista) {

	olio* tmp = lista;

	while(tmp) {
		if ( volkkari_x < (tmp->x + tmp->w) && volkkari_y < ((vieritty + SCREEN_H) - tmp->y) && (tmp->x - 1) < (volkkari_x+50) && ((vieritty+SCREEN_H)-(tmp->y+tmp->h)) < (volkkari_y + 100)) {
			switch(tmp->tyyppi) {
				case BILE:
					return BILE_KOLARI;
					break;
				case JALKA:
					//loki("\t\t SPLT \n");
					return JALKA_KOLARI;
					break;
				case KOTA:
					return EI_KOLARI;
					break;
				case NAMU:
					if(!tmp->kuollut) {
						tmp->kuollut = 1;
						return NAMU_KOLARI;
						break;
					}
				default:
					return EI_KOLARI;
					break;
			}
		}
		tmp = (olio *)tmp->seuraava;
	}
	
	return EI_KOLARI; /* ei trmyksi */
}

void paivita(olio* lista) {
	int tormatty = EI_KOLARI;

	// sitten nppimist
	if(key[KEY_LEFT]) {
		volkkari_x-=(kerroin*0.5)+1;
		if(volkkari_x<VASEN_RAJA)
			volkkari_x=VASEN_RAJA;
	} else if(key[KEY_RIGHT]) {
		volkkari_x+=(kerroin*0.5)+1;
		if(volkkari_x>OIKEA_RAJA-50)
			volkkari_x = OIKEA_RAJA-50;
	}

	if(key[KEY_UP]) {
		if(kaasuttu==0)
			kerroin++;
		kaasuttu++;
		if(kaasuttu>3)
			kaasuttu=0;
		if(kerroin>9)
			kerroin = 9;
	} else {
		if(kaasuttu==0)
			kerroin--;
		kaasuttu++;
		if(kaasuttu<6)
			kaasuttu=0;
		if(kerroin<1)
			kerroin = 1;
	}
	if(key[KEY_DOWN]) {
		if(jarruttu==0)
			kerroin++;
		jarruttu++;
		if(jarruttu>3)
			jarruttu = 0;
		kerroin--;
		if(kerroin<1)
			kerroin = 1;
	}

	tormatty = olio_tormays_testi(lista);
	switch(tormatty) {
		case EI_KOLARI:
			kolari=0;
			break;
		case BILE_KOLARI:
			play_sample((AL_CONST SAMPLE *)datfile[SFX_OHNO].dat,128,128,1000,0);
			kolari=1;
			break;
		case JALKA_KOLARI:
			play_sample((AL_CONST SAMPLE *)datfile[SFX_OHNO].dat,128,128,1000,0);
			kolari=1;
			break;
		case NAMU_KOLARI:
			play_sample((AL_CONST SAMPLE *)datfile[SFX_BONUS].dat,128,128,1000,0);
			bonus=1;
			saadut_bonukset++;
			break;
		default:
			kolari=0;
			break;
	}
}
